#!/usr/bin/python3
# -*- coding: utf-8 -*-
import argparse
import base64
import serial
import struct
import time
import sys

class SerialWrapper(serial.Serial):
    def read(self, *args, **kw):
        data = super(SerialWrapper,self).read(*args,**kw)
        sys.stderr.write(data.decode('ascii'))
        return data

    def write(self, data):
        #sys.stderr.write(data.replace(b'\r',b'\n').decode('ascii'))
        return super(SerialWrapper,self).write(data)

class ConsoleHandler(object):
    class DeviceError(Exception):
        pass

    class Si4688Timeout(DeviceError):
        pass

    def __init__(self, device):
        self.device = device

    def close(self):
        self.device.close()
        del self.device

    def run_simple_command(self, cmd):
        d = self.device

        cmd = cmd.encode()
        d.write(cmd + b'\r')
        d.flush()

        r = self.line_reader(d)
        l = next(r)

        if l != cmd:
            raise self.DeviceError(u'Unexpected command mirror "{}" after command {}'.format(l, cmd))

        for l in r:
            if l.startswith(b'#'):
                raise self.DeviceError(u'Command {} failed: {}'.format(cmd, l[1:]))

        if l != b'$ ':
            raise self.DeviceError(u'Unexpected prompt "{}" after command {}'.format(l, cmd))

    def run_i2c_transfer(self, addr, write_data, read_len):
        d = self.device

        write_data = base64.b64encode(write_data)

        cmd = ('i2c {} {}'.format(addr, read_len)).encode()
        d.write(cmd + b'\r')
        d.flush()

        r = self.line_reader(d)
        l = next(r)

        if l != cmd:
            raise self.DeviceError(u'Unexpected command mirror "{}" after command {}'.format(l, cmd))

        for l in r:
            if l.startswith(b'#'):
                raise self.DeviceError(u'Command {} failed: {}'.format(cmd, l[1:]))
            elif l.startswith(b'!=== Starting I2C transfer with '):
                break

        while write_data:
            block = write_data[0:32]
            write_data = write_data[32:]

            d.write(block)
            d.flush()

            m = d.read(len(block))
            if(block != m):
                raise self.DeviceError(u'Unexpected data mirror "{}" for "{}"'.format(m, block))

        d.write(b'\r')
        d.flush()

        r = self.line_reader(d)

        if(read_len > 0):
            read_data = next(r)
        else:
            read_data = ''

        for l in r:
            if l.startswith(b'#'):
                raise self.DeviceError(u'Command {} failed: {}'.format(cmd, l[1:]))

        if l != b'$ ':
            raise self.DeviceError(u'Unexpected prompt "{}" after command {}'.format(l, cmd))

        retval = base64.b64decode(read_data)
        if(len(retval) != read_len):
            raise self.DeviceError(u'Unexpected read data length {}'.format(len(retval)))

        return retval

    i2caddr_si4688 = 0x64


    def read_si_reply(self, len = 0, timeout = 10):
        status = (0,0,0,0)

        ts_timeout = timeout + time.time()
        while (status[0] & 0x80) == 0:
            data = self.run_i2c_transfer(self.i2caddr_si4688, struct.pack('<B', 0), 4)
            status = struct.unpack('<4B', data)

            if time.time() > ts_timeout:
                raise self.Si4688Timeout(u'Timeout waiting for ready response')

        print(u'Si4688 Status: {:02x} {:02x} {:02x} {:02x}'.format(*status))

        if status[0] & 0x40:
            raise self.DeviceError(u'Si4688 command failed')

        if(len > 0):
            data = self.run_i2c_transfer(self.i2caddr_si4688, struct.pack('<B', 0), 4 + len)

        return struct.unpack('<4B', data[0:4]), data[4:]

    CMD_FLASH_PASS_THROUGH = 0x05
    CMD_LOAD_INIT          = 0x06

    def do_si_command(self, command_bytes):
        self.run_i2c_transfer(self.i2caddr_si4688, command_bytes, 0)

    def do_si_load_init(self):
        self.do_si_command(struct.pack('<BB', 0x06, 0x0))
        self.read_si_reply()

    SUBCMD_FLASH_ERASE_CHIP = 0xFF
    SUBCMD_FLASH_WRITE_BLOCK = 0xF0
    SUBCMD_FLASH_WRITE_BLOCK_PACKET_VERIFY = 0xF2
    SUBCMD_FLASH_WRITE_BLOCK_READBACK_AND_PACKET_VERIFY = 0xF3

    def do_si_write_flash(self, address, blob):

        #crc = binascii.crc32(blob) & 0xFFFFFFFF
        #data = struct.pack('<B BB L L L', self.SUBCMD_FLASH_WRITE_BLOCK_READBACK_AND_PACKET_VERIFY,
        #                   0x0C, 0xED, crc, address, len(blob)) + blob

        data = struct.pack('<B B BB l L L', self.CMD_FLASH_PASS_THROUGH, self.SUBCMD_FLASH_WRITE_BLOCK,
                           0x0C, 0xED, 0 , address, len(blob)) + blob

        self.do_si_command(data)
        self.read_si_reply()



    @classmethod
    def line_reader(cls, device):
        buffer = b''
        while buffer != b'$ ':
            data = device.read(device.in_waiting or 1)

            if not data:
                break

            buffer = buffer + data

            while buffer:
                a,b = buffer.find(b'\n'), buffer.find(b'\r')

                if a < 0:
                    i = b
                elif b < 0:
                    i = a
                else:
                    i=min(a,b)

                if i > 0:
                    # line with content
                    yield buffer[0:i]
                    buffer = buffer[i+1:]
                elif i == 0:
                    # empty line
                    buffer = buffer[i+1:]
                else:
                    break
        if buffer:
            yield buffer

    def prepare(self):
        ser = self.device
        print(ser)

        for i in range(10):
            ser.write(b'help\r')
            ser.flush()

            buffer = b''
            while True:
                data = ser.read(1000)

                if not data:
                    break

                buffer = buffer + data

            if buffer[-2:] == b'$ ':
                break

            time.sleep(0.5)
        else:
            print(buffer)

            if buffer[-2:] != b'$ ':
                raise self.DeviceError(u'Timeout reading the expected response')

    @classmethod
    def argument(cls, string):
        try:
            ser = SerialWrapper(port=string, baudrate=115200, bytesize=serial.EIGHTBITS, timeout=1)
        except Exception as e:
            raise cls.DeviceError(u'Exception {}'.format(e))

        ser.reset_input_buffer()
        ser.reset_output_buffer()

        # WARNING: After opening the serial console, a reset on the ARDUINO might be triggered
        # Since the ARDUINO application will take some time to boot, we have to retry connection for a while
        # until it responds.

        return cls(ser)

si_rom_patch = [
    0x10, 0x00, 0x00, 0xff, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x78, 0x56, 0x34, 0x12,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xfd, 0x84, 0xcb, 0x6c, 0x01, 0x00, 0x00, 0x00,
    0xef, 0xbe, 0xad, 0xde, 0x48, 0x16, 0x00, 0x00, 0x04, 0x00, 0x00, 0x00, 0x04, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x44, 0x05, 0x20, 0x50, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x88, 0xcf, 0x6f, 0x07, 0x6f, 0x00, 0x00, 0x81, 0x00, 0xd8, 0x00, 0x50,
    0x48, 0xe0, 0x00, 0x50, 0x50, 0xe1, 0x00, 0x50, 0x00, 0x2a, 0x00, 0x50, 0xac, 0x67, 0x28, 0x50,
    0x6c, 0x65, 0x28, 0x50, 0x00, 0x2e, 0x00, 0xa0, 0x80, 0x2a, 0x00, 0x50, 0xa0, 0x96, 0x28, 0x50,
    0x0c, 0xff, 0xf0, 0xff, 0x00, 0x1e, 0x00, 0xa0, 0x80, 0xff, 0xff, 0x4f, 0xe8, 0x95, 0x28, 0x50,
    0x40, 0x00, 0x00, 0x50, 0xf8, 0x92, 0x28, 0x50, 0x50, 0x00, 0x00, 0x50, 0x60, 0x00, 0x00, 0x50,
    0x00, 0x00, 0xff, 0xff, 0x03, 0x10, 0x00, 0x00, 0xa8, 0x08, 0x20, 0x50, 0xc8, 0x08, 0x20, 0x50,
    0x74, 0x08, 0x20, 0x50, 0xe0, 0x07, 0x20, 0x50, 0xf0, 0x09, 0x20, 0x50, 0x60, 0x06, 0x20, 0x50,
    0x00, 0xfe, 0x00, 0x50, 0x03, 0x04, 0x20, 0x90, 0xfc, 0x08, 0x20, 0x50, 0x78, 0x67, 0x28, 0x50,
    0x50, 0x2a, 0x00, 0x50, 0x00, 0x22, 0x00, 0x50, 0xff, 0xff, 0x1f, 0x50, 0x00, 0x00, 0x26, 0x50,
    0x00, 0x0e, 0x00, 0xa0, 0xd4, 0x97, 0x28, 0x50, 0x00, 0x8e, 0x00, 0x50, 0x00, 0xf3, 0x03, 0xa0,
    0xff, 0xef, 0xff, 0xff, 0x00, 0xbe, 0x02, 0xa0, 0x34, 0x25, 0x00, 0x50, 0xe0, 0x27, 0x00, 0x50,
    0x34, 0xe1, 0x00, 0x50, 0x30, 0xe1, 0x00, 0x50, 0xa8, 0x60, 0x28, 0x50, 0x98, 0x51, 0x28, 0x50,
    0xff, 0xff, 0x0f, 0x00, 0x00, 0x00, 0xf0, 0xff, 0x94, 0x65, 0x28, 0x50, 0x50, 0xe0, 0x00, 0x50,
    0x0c, 0xed, 0x00, 0x00, 0xc0, 0xde, 0x00, 0x00, 0xde, 0xc0, 0x00, 0x00, 0x58, 0x66, 0x28, 0x50,
    0x00, 0xe0, 0x00, 0x50, 0xb7, 0x0b, 0x00, 0x00, 0x50, 0xc3, 0x00, 0x00, 0x00, 0xbe, 0x00, 0xa0,
    0xb0, 0xe0, 0x00, 0x50, 0x70, 0xa5, 0x28, 0x50, 0x00, 0x00, 0x00, 0x03, 0x00, 0xfe, 0xff, 0x9f,
    0x00, 0x10, 0x00, 0x00, 0xc0, 0x20, 0x00, 0xa0, 0xf3, 0x00, 0x0f, 0x00, 0xd0, 0x20, 0x00, 0xa0,
    0xe0, 0x20, 0x00, 0xa0, 0xf0, 0x20, 0x00, 0xa0, 0x04, 0x10, 0x00, 0xa0, 0x00, 0x08, 0x00, 0x00,
    0x80, 0xc0, 0x00, 0xa0, 0xa8, 0xe0, 0x00, 0x50, 0x90, 0xc0, 0x00, 0xa0, 0xff, 0xff, 0x00, 0x00,
    0xf0, 0xc0, 0x00, 0xa0, 0x10, 0xc0, 0x00, 0xa0, 0x70, 0xc0, 0x00, 0xa0, 0x44, 0x15, 0x20, 0x50,
    0x00, 0xc1, 0x00, 0xa0, 0xf0, 0x10, 0x00, 0xa0, 0x44, 0x10, 0x00, 0xa0, 0x00, 0x31, 0x00, 0xa0,
    0x60, 0x10, 0x00, 0xa0, 0x80, 0x10, 0x00, 0xa0, 0xf0, 0x11, 0x00, 0xa0, 0x00, 0x00, 0xc0, 0x00,
    0x00, 0x00, 0x40, 0x00, 0x20, 0x4e, 0x00, 0x00, 0xa4, 0xa6, 0x28, 0x50, 0x00, 0x00, 0x50, 0xc3,
    0x08, 0x88, 0x00, 0x00, 0xe3, 0xff, 0x01, 0x00, 0x08, 0x10, 0x00, 0xa0, 0xff, 0x37, 0xfc, 0xef,
    0xff, 0x3f, 0xfc, 0xef, 0xe0, 0xc0, 0x00, 0xa0, 0x00, 0x00, 0x06, 0x00, 0x00, 0x00, 0x04, 0x00,
    0x10, 0xc1, 0x00, 0xa0, 0x20, 0xc1, 0x00, 0xa0, 0x60, 0xc0, 0x00, 0xa0, 0x00, 0x00, 0x02, 0x00,
    0x80, 0xa5, 0x28, 0x50, 0x00, 0x00, 0x00, 0x02, 0x20, 0xe0, 0x00, 0x50, 0x50, 0x4c, 0x28, 0x50,
    0x30, 0xe0, 0x00, 0x50, 0x40, 0xe1, 0x00, 0x50, 0x00, 0xde, 0x03, 0xa0, 0xf7, 0x03, 0x01, 0x00,
    0xe7, 0x03, 0x01, 0x00, 0x17, 0x10, 0x00, 0x00, 0x37, 0x10, 0x00, 0x00, 0x11, 0x00, 0x00, 0x81,
    0x00, 0xe0, 0x00, 0x50, 0xa8, 0x61, 0x03, 0x03, 0x0b, 0x00, 0x4b, 0x00, 0x02, 0x20, 0x04, 0x00,
    0xc7, 0x40, 0x00, 0x00, 0x00, 0x00, 0x0e, 0x50, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x3c, 0x42, 0x49, 0x46, 0x5f, 0x48, 0x44, 0x52, 0x5f, 0x53, 0x45, 0x43,
    0x54, 0x4e, 0x3e, 0x0a, 0x3c, 0x2f, 0x42, 0x49, 0x46, 0x5f, 0x48, 0x44, 0x52, 0x5f, 0x53, 0x45,
    0x43, 0x54, 0x4e, 0x3e, 0x0a, 0x00, 0x00, 0x00, 0x42, 0x00, 0x00, 0x21, 0x48, 0xe0, 0x00, 0x50,
    0x0a, 0x05, 0x00, 0x80, 0x00, 0x04, 0x20, 0x50, 0x36, 0x41, 0x00, 0x21, 0x02, 0x32, 0xc0, 0x20,
    0x00, 0x92, 0x22, 0x15, 0xc0, 0x20, 0x00, 0x82, 0x22, 0x14, 0x97, 0x98, 0x0e, 0xc0, 0x20, 0x00,
    0xb2, 0x22, 0x15, 0xc0, 0x20, 0x00, 0xa2, 0x22, 0x14, 0xb7, 0x1a, 0xf0, 0x65, 0x00, 0x00, 0xc6,
    0xf6, 0xff, 0x00, 0x00, 0x36, 0x41, 0x00, 0x21, 0x02, 0x32, 0xc0, 0x20, 0x00, 0x32, 0x22, 0x14,
    0x20, 0x33, 0xa0, 0xc0, 0x20, 0x00, 0x52, 0x23, 0x1a, 0x52, 0x05, 0x00, 0xc0, 0x20, 0x00, 0x42,
    0x23, 0x1a, 0x1b, 0x44, 0xc0, 0x20, 0x00, 0x0c, 0x4a, 0x0c, 0x1b, 0x32, 0x23, 0x1e, 0x81, 0x03,
    0x32, 0x0b, 0x93, 0x30, 0x39, 0x93, 0xe0, 0x08, 0x00, 0x26, 0x45, 0x2b, 0x26, 0x55, 0x46, 0x26,
    0x65, 0x50, 0x26, 0x75, 0x5a, 0x26, 0x85, 0x60, 0x0c, 0x98, 0x87, 0x15, 0x64, 0x26, 0x95, 0x6a,
    0x0c, 0xb9, 0x97, 0x15, 0x6e, 0xa2, 0xa0, 0xcf, 0xa7, 0x15, 0x1d, 0x81, 0x04, 0x32, 0x0c, 0x1a,
    0xe0, 0x08, 0x00, 0x0c, 0x1a, 0xc6, 0x02, 0x00, 0xbd, 0x03, 0x82, 0x22, 0x23, 0xad, 0x04, 0xe0,
    0x08, 0x00, 0x0c, 0x0a, 0x25, 0x4e, 0x00, 0x1d, 0xf0, 0xbd, 0x03, 0x82, 0x22, 0x2b, 0xad, 0x04,
    0xe0, 0x08, 0x00, 0x06, 0xf7, 0xff, 0xbd, 0x03, 0x82, 0x22, 0x24, 0xad, 0x04, 0xe0, 0x08, 0x00,
    0xc6, 0xf3, 0xff, 0xbd, 0x03, 0x82, 0x22, 0x25, 0xad, 0x04, 0xe0, 0x08, 0x00, 0x86, 0xf0, 0xff,
    0x82, 0x22, 0x26, 0xe0, 0x08, 0x00, 0x46, 0xee, 0xff, 0x82, 0x22, 0x27, 0xe0, 0x08, 0x00, 0x06,
    0xec, 0xff, 0x82, 0x22, 0x28, 0xe0, 0x08, 0x00, 0xc6, 0xe9, 0xff, 0x82, 0x22, 0x29, 0xe0, 0x08,
    0x00, 0x86, 0xe7, 0xff, 0x82, 0x22, 0x2a, 0xe0, 0x08, 0x00, 0x46, 0xe5, 0xff, 0x00, 0x00, 0x00,
    0x36, 0x41, 0x00, 0xa2, 0xa0, 0x80, 0x21, 0x05, 0x32, 0xc0, 0x20, 0x00, 0x92, 0x22, 0xc4, 0xa0,
    0x99, 0x20, 0xc0, 0x20, 0x00, 0x81, 0x06, 0x32, 0x92, 0x62, 0xc4, 0x82, 0x08, 0x08, 0xac, 0x88,
    0x0c, 0x1a, 0xc0, 0x20, 0x00, 0x92, 0x22, 0xcc, 0xa0, 0x99, 0x20, 0xc0, 0x20, 0x00, 0x92, 0x62,
    0xcc, 0x81, 0x07, 0x32, 0x0c, 0xda, 0xe0, 0x08, 0x00, 0x7c, 0xec, 0xc0, 0x20, 0x00, 0xb2, 0x22,
    0xcc, 0xc0, 0xbb, 0x10, 0xc0, 0x20, 0x00, 0xb2, 0x62, 0xcc, 0x1d, 0xf0, 0x36, 0x41, 0x00, 0x0c,
    0x4a, 0x81, 0x03, 0x32, 0x0c, 0x0b, 0xe0, 0x08, 0x00, 0x0c, 0x17, 0x41, 0x08, 0x32, 0x31, 0x09,
    0x32, 0x51, 0x06, 0x32, 0x62, 0xa0, 0xf2, 0x92, 0x05, 0x08, 0x21, 0x05, 0x32, 0x9c, 0xf9, 0xc0,
    0x20, 0x00, 0xb2, 0x22, 0xcc, 0x70, 0xbb, 0x20, 0xc0, 0x20, 0x00, 0xb2, 0x62, 0xcc, 0xc0, 0x20,
    0x00, 0xa2, 0x23, 0x90, 0x40, 0xaa, 0x10, 0x60, 0xaa, 0x20, 0xc0, 0x20, 0x00, 0xa2, 0x63, 0x90,
    0xe5, 0x11, 0x01, 0xc1, 0x0a, 0x32, 0xc2, 0x0c, 0x89, 0x37, 0xec, 0x35, 0xa2, 0xa0, 0x50, 0xb2,
    0xa0, 0x04, 0x81, 0x0b, 0x32, 0xc1, 0x0c, 0x32, 0xe0, 0x08, 0x00, 0xa1, 0x0c, 0x32, 0x81, 0x0d,
    0x32, 0xb1, 0x0e, 0x32, 0xe0, 0x08, 0x00, 0xa2, 0xa0, 0x60, 0xb2, 0xa0, 0x04, 0x81, 0x0b, 0x32,
    0xc1, 0x0c, 0x32, 0xe0, 0x08, 0x00, 0xa1, 0x0c, 0x32, 0x81, 0x0d, 0x32, 0xb1, 0x0f, 0x32, 0xe0,
    0x08, 0x00, 0x4c, 0x0a, 0x0c, 0x4b, 0x81, 0x0b, 0x32, 0xc1, 0x0c, 0x32, 0xe0, 0x08, 0x00, 0xc1,
    0x10, 0x32, 0xa1, 0x11, 0x32, 0xb1, 0x02, 0x32, 0xc0, 0x20, 0x00, 0x92, 0x22, 0x84, 0xc0, 0x99,
    0x10, 0xa0, 0x99, 0x20, 0xc0, 0x20, 0x00, 0xa1, 0x17, 0x32, 0xc1, 0x16, 0x32, 0xd1, 0x15, 0x32,
    0xe1, 0x14, 0x32, 0xf1, 0x13, 0x32, 0x92, 0x62, 0x84, 0x81, 0x12, 0x32, 0x82, 0x6b, 0x28, 0xf2,
    0x6b, 0x2b, 0xe2, 0x6b, 0x25, 0xd2, 0x6b, 0x23, 0xc2, 0x6b, 0x24, 0xa2, 0x6b, 0x26, 0x92, 0x05,
    0x08, 0x9c, 0xf9, 0xc0, 0x20, 0x00, 0xe2, 0x22, 0xcc, 0x70, 0xee, 0x20, 0xc0, 0x20, 0x00, 0xe2,
    0x62, 0xcc, 0xc0, 0x20, 0x00, 0xd2, 0x23, 0x90, 0x40, 0xdd, 0x10, 0x60, 0xdd, 0x20, 0xc0, 0x20,
    0x00, 0xd2, 0x63, 0x90, 0xb1, 0x1a, 0x32, 0xc1, 0x1c, 0x32, 0xa1, 0x18, 0x32, 0x91, 0x19, 0x32,
    0x81, 0x1b, 0x32, 0x92, 0x6a, 0x5c, 0x0c, 0x4a, 0xe0, 0x08, 0x00, 0x0c, 0x4a, 0x81, 0x03, 0x32,
    0x0c, 0x1b, 0xe0, 0x08, 0x00, 0x1d, 0xf0, 0x00, 0x36, 0x41, 0x00, 0x81, 0x05, 0x32, 0xc0, 0x20,
    0x00, 0x82, 0x28, 0xd8, 0x80, 0x80, 0x34, 0x66, 0x38, 0x02, 0xa5, 0x0f, 0x00, 0x65, 0x00, 0x00,
    0x1d, 0xf0, 0x00, 0x00, 0x36, 0x61, 0x00, 0x0c, 0x15, 0xb1, 0x05, 0x32, 0xc0, 0x20, 0x00, 0x82,
    0x2b, 0xd8, 0x31, 0x1d, 0x32, 0x80, 0x80, 0x34, 0x26, 0x38, 0x2e, 0x0c, 0x4a, 0x81, 0x03, 0x32,
    0x0c, 0x0b, 0xe0, 0x08, 0x00, 0x81, 0x04, 0x32, 0x0c, 0x1a, 0xe0, 0x08, 0x00, 0xa1, 0x02, 0x32,
    0xc0, 0x20, 0x00, 0x52, 0x6a, 0x16, 0x0c, 0x09, 0xc0, 0x20, 0x00, 0x0c, 0x1b, 0x92, 0x6a, 0x18,
    0x81, 0x03, 0x32, 0x0c, 0x4a, 0xe0, 0x08, 0x00, 0x1d, 0xf0, 0x0c, 0x02, 0x92, 0x23, 0xd2, 0x42,
    0x23, 0xcd, 0xc2, 0x23, 0xd1, 0xf1, 0x1e, 0x32, 0xf6, 0x4c, 0x09, 0x0c, 0xed, 0x0c, 0x62, 0x90,
    0x2d, 0x83, 0x06, 0x01, 0x00, 0x0c, 0x4e, 0x90, 0x2e, 0x93, 0x47, 0xbf, 0x05, 0x81, 0x1f, 0x32,
    0x47, 0xb8, 0x02, 0x50, 0x22, 0x20, 0xe2, 0xae, 0x0f, 0x91, 0x20, 0x32, 0xc0, 0x20, 0x00, 0xd2,
    0x2b, 0xd8, 0xe0, 0xdd, 0x10, 0xc0, 0x20, 0x00, 0xd2, 0x6b, 0xd8, 0xc2, 0xa1, 0xf0, 0xc0, 0x20,
    0x00, 0xa2, 0x2b, 0xd8, 0xc0, 0xaa, 0x20, 0xc0, 0x20, 0x00, 0xa2, 0x6b, 0xd8, 0xc0, 0x20, 0x00,
    0x52, 0x69, 0x9e, 0xc0, 0x20, 0x00, 0x52, 0x69, 0x96, 0xc0, 0x20, 0x00, 0x52, 0x69, 0x96, 0x65,
    0x09, 0x00, 0xf1, 0x0a, 0x32, 0xf2, 0x0f, 0x89, 0x57, 0xef, 0x05, 0x81, 0x21, 0x32, 0xe0, 0x08,
    0x00, 0x0c, 0x4a, 0x81, 0x03, 0x32, 0x0c, 0x0b, 0xe0, 0x08, 0x00, 0xc8, 0x11, 0xb8, 0x01, 0xa2,
    0x23, 0xd0, 0x91, 0x22, 0x32, 0x8d, 0x09, 0x9d, 0x0a, 0x3d, 0x04, 0xf2, 0xa5, 0x02, 0x80, 0xff,
    0x11, 0xe2, 0xa0, 0x86, 0xea, 0xff, 0x40, 0xff, 0x11, 0xe2, 0xa1, 0xea, 0xea, 0xff, 0xa0, 0x0f,
    0x00, 0x1d, 0xf0, 0x00, 0x36, 0x41, 0x00, 0x81, 0x0a, 0x32, 0x82, 0x08, 0x89, 0x0c, 0x1a, 0x47,
    0x68, 0x3d, 0x0c, 0x2d, 0xb1, 0x20, 0x32, 0xc0, 0x20, 0x00, 0xc2, 0x2b, 0x98, 0xd0, 0xcc, 0x20,
    0xc0, 0x20, 0x00, 0xc2, 0x6b, 0x98, 0xc0, 0x20, 0x00, 0x92, 0x2b, 0x98, 0xa0, 0x99, 0x20, 0xc0,
    0x20, 0x00, 0x81, 0x07, 0x32, 0x92, 0x6b, 0x98, 0xe0, 0x08, 0x00, 0x82, 0xa1, 0x00, 0xf1, 0x23,
    0x32, 0xc0, 0x20, 0x00, 0xe2, 0x1f, 0x20, 0x80, 0xee, 0x20, 0xc0, 0x20, 0x00, 0xe2, 0x5f, 0x20,
    0x1d, 0xf0, 0x00, 0x00, 0x36, 0x41, 0x00, 0x21, 0x0a, 0x32, 0x81, 0x24, 0x32, 0x22, 0x02, 0x89,
    0x41, 0x25, 0x32, 0x27, 0xe2, 0x0e, 0xc0, 0x20, 0x00, 0x32, 0x24, 0x8c, 0x80, 0x33, 0x10, 0xc0,
    0x20, 0x00, 0x32, 0x64, 0x8c, 0x1d, 0xf0, 0x00, 0x36, 0x41, 0x00, 0x7c, 0x05, 0x41, 0x05, 0x32,
    0xb6, 0x33, 0x05, 0x32, 0xc3, 0xfd, 0x86, 0x00, 0x00, 0x32, 0xa0, 0x00, 0xc0, 0x20, 0x00, 0x82,
    0x24, 0xd8, 0x80, 0x80, 0x34, 0x66, 0x28, 0x33, 0x30, 0xd3, 0x20, 0xc2, 0xc2, 0x03, 0xa1, 0x26,
    0x32, 0xb1, 0x27, 0x32, 0x25, 0xdc, 0x00, 0x16, 0xba, 0x04, 0xc0, 0x20, 0x00, 0xb2, 0x24, 0xd8,
    0x50, 0xbb, 0x10, 0xc0, 0x20, 0x00, 0xb2, 0x64, 0xd8, 0x0c, 0x3a, 0xc0, 0x20, 0x00, 0x92, 0x24,
    0xd8, 0xa0, 0x99, 0x20, 0xc0, 0x20, 0x00, 0x92, 0x64, 0xd8, 0x1d, 0xf0, 0xc0, 0x20, 0x00, 0xb2,
    0x24, 0xd8, 0x50, 0xbb, 0x10, 0xc0, 0x20, 0x00, 0xb2, 0x64, 0xd8, 0x0c, 0x7a, 0xc0, 0x20, 0x00,
    0x92, 0x24, 0xd8, 0xa0, 0x99, 0x20, 0xc0, 0x20, 0x00, 0x92, 0x64, 0xd8, 0x81, 0x04, 0x32, 0x0c,
    0x1a, 0xe0, 0x08, 0x00, 0x1d, 0xf0, 0xc1, 0x1d, 0x32, 0xc2, 0x2c, 0xf3, 0x16, 0x4c, 0xff, 0x81,
    0x04, 0x32, 0x0c, 0x1a, 0xe0, 0x08, 0x00, 0x1d, 0xf0, 0x00, 0x00, 0x00, 0x36, 0x41, 0x00, 0xb6,
    0x33, 0x14, 0x82, 0x02, 0x00, 0xa2, 0xa0, 0xff, 0xa7, 0x98, 0x0b, 0x92, 0x02, 0x01, 0xb2, 0x02,
    0x02, 0xa7, 0x99, 0x02, 0xa7, 0x1b, 0x15, 0x81, 0x2a, 0x32, 0xa1, 0x28, 0x32, 0xb1, 0x29, 0x32,
    0x0c, 0x09, 0x99, 0x0b, 0x99, 0x0a, 0xbd, 0x03, 0xad, 0x02, 0xe0, 0x08, 0x00, 0x1d, 0xf0, 0x00,
    0x36, 0x41, 0x00, 0x31, 0x02, 0x32, 0x21, 0x05, 0x32, 0xc0, 0x20, 0x00, 0x22, 0x22, 0xd8, 0x20,
    0x20, 0x34, 0x80, 0x22, 0x11, 0xc0, 0x20, 0x00, 0x22, 0x63, 0x30, 0x1d, 0xf0, 0x00, 0x00, 0x00,
    0x36, 0x81, 0x00, 0x0c, 0xf8, 0x87, 0x93, 0x26, 0xa2, 0xa0, 0x60, 0x0c, 0x4b, 0x81, 0x0b, 0x32,
    0xcd, 0x01, 0xe0, 0x08, 0x00, 0xad, 0x01, 0x81, 0x0d, 0x32, 0xb2, 0xc1, 0x10, 0xe0, 0x08, 0x00,
    0x98, 0x41, 0x90, 0x90, 0xf4, 0xcc, 0x69, 0x81, 0x2b, 0x32, 0xad, 0x02, 0xe0, 0x08, 0x00, 0x1d,
    0xf0, 0x00, 0x00, 0x00, 0x36, 0x41, 0x00, 0xa8, 0x12, 0x0c, 0x1d, 0x20, 0xba, 0xa0, 0x98, 0x6b,
    0xc1, 0x05, 0x32, 0x92, 0x09, 0x00, 0xc0, 0x20, 0x00, 0x82, 0x2c, 0x98, 0x80, 0x80, 0xf4, 0x89,
    0xab, 0x1b, 0xba, 0xe8, 0x52, 0x0c, 0x0a, 0x66, 0x79, 0x04, 0xd9, 0x42, 0x06, 0x01, 0x00, 0x26,
    0x49, 0x01, 0xd9, 0x32, 0xe7, 0xbb, 0x01, 0xad, 0x0b, 0xe1, 0x2c, 0x32, 0x20, 0x9a, 0xa0, 0x98,
    0x69, 0xb1, 0x2d, 0x32, 0xe0, 0x99, 0x10, 0xc0, 0x20, 0x00, 0x82, 0x2c, 0x80, 0xb0, 0x88, 0x10,
    0x90, 0x88, 0x20, 0xc0, 0x20, 0x00, 0x82, 0x6c, 0x80, 0xf8, 0x42, 0xa9, 0x12, 0xdc, 0xaf, 0xb8,
    0x02, 0xc8, 0x32, 0xa7, 0x9b, 0x06, 0x0c, 0x19, 0xd9, 0x22, 0x46, 0x00, 0x00, 0x98, 0x22, 0x26,
    0x19, 0x08, 0x26, 0x1c, 0x05, 0x81, 0x2e, 0x32, 0xe0, 0x08, 0x00, 0x0c, 0x4a, 0x81, 0x03, 0x32,
    0x0c, 0x1b, 0xe0, 0x08, 0x00, 0x1d, 0xf0, 0x00, 0x36, 0x41, 0x00, 0x0c, 0x4a, 0x81, 0x03, 0x32,
    0x0c, 0x0b, 0xe0, 0x08, 0x00, 0x0c, 0x04, 0x31, 0x02, 0x32, 0xc0, 0x20, 0x00, 0xb2, 0x23, 0x14,
    0x1b, 0xbb, 0xc0, 0x20, 0x00, 0xb2, 0x63, 0x14, 0xc0, 0x20, 0x00, 0xa2, 0x23, 0x19, 0xc0, 0x20,
    0x00, 0x92, 0x23, 0x14, 0xa7, 0x39, 0x05, 0xc0, 0x20, 0x00, 0x42, 0x63, 0x14, 0xc0, 0x20, 0x00,
    0xc2, 0x23, 0x17, 0x9c, 0x3c, 0x66, 0x12, 0x22, 0x65, 0xb3, 0xff, 0xc0, 0x20, 0x00, 0x42, 0x63,
    0x17, 0xc0, 0x20, 0x00, 0x42, 0x63, 0x16, 0x06, 0x04, 0x00, 0xc0, 0x20, 0x00, 0xd2, 0x23, 0x16,
    0x8c, 0x7d, 0xe5, 0xb1, 0xff, 0xc0, 0x20, 0x00, 0x42, 0x63, 0x16, 0x0c, 0x4a, 0x81, 0x03, 0x32,
    0x0c, 0x1b, 0xe0, 0x08, 0x00, 0x1d, 0xf0, 0x00, 0x36, 0x41, 0x00, 0xb6, 0x33, 0x70, 0xa1, 0x2f,
    0x32, 0x65, 0x68, 0x00, 0xa2, 0x02, 0x00, 0x41, 0x02, 0x32, 0x16, 0x3a, 0x06, 0xe6, 0x3a, 0x02,
    0xe6, 0x1a, 0x37, 0x82, 0xca, 0xf0, 0x16, 0x78, 0x16, 0x92, 0xca, 0xef, 0x16, 0x99, 0x16, 0xb2,
    0xa0, 0xf3, 0xa7, 0x2b, 0x05, 0xc2, 0xa0, 0xf0, 0xc7, 0xaa, 0x55, 0xd2, 0xa0, 0xf4, 0xd0, 0xda,
    0xc0, 0x16, 0xcd, 0x16, 0xe2, 0xa0, 0xfe, 0xe0, 0xea, 0xc0, 0x16, 0x4e, 0x0d, 0xf2, 0xa0, 0xff,
    0xf0, 0xfa, 0xc0, 0x16, 0x3f, 0x11, 0x0c, 0x02, 0x06, 0x05, 0x00, 0x0c, 0xe8, 0x37, 0xb8, 0x0d,
    0x3b, 0xb2, 0xc2, 0xc3, 0xfd, 0xa5, 0x16, 0x00, 0xc0, 0x20, 0x00, 0xa2, 0x64, 0x30, 0x0c, 0x12,
    0xe5, 0x7b, 0x00, 0x56, 0x82, 0x00, 0x81, 0x04, 0x32, 0xa2, 0xa0, 0x01, 0xe0, 0x08, 0x00, 0x1d,
    0xf0, 0x0c, 0xa9, 0x37, 0xb9, 0xe7, 0x3b, 0xb2, 0xc2, 0xc3, 0xfd, 0x65, 0x14, 0x00, 0x06, 0xf7,
    0xff, 0xf6, 0xb3, 0x02, 0x46, 0x21, 0x00, 0xc1, 0x30, 0x32, 0xb2, 0x02, 0x02, 0xd2, 0x02, 0x01,
    0x80, 0xbb, 0x11, 0xd0, 0xbb, 0x20, 0xc7, 0x9b, 0x73, 0xb2, 0xc2, 0x0f, 0x82, 0x02, 0x09, 0x92,
    0x02, 0x04, 0xf2, 0x02, 0x05, 0xd2, 0xc3, 0xf1, 0xc2, 0x02, 0x0e, 0xe2, 0x02, 0x0d, 0x80, 0xcc,
    0x11, 0xe0, 0xcc, 0x20, 0xe2, 0x02, 0x0c, 0x80, 0xcc, 0x11, 0xe0, 0xcc, 0x20, 0xe2, 0x02, 0x0b,
    0x80, 0xcc, 0x11, 0xe0, 0xcc, 0x20, 0xd0, 0xcc, 0x63, 0xe2, 0x02, 0x06, 0xd2, 0xaf, 0x10, 0xd0,
    0xda, 0x80, 0x80, 0xee, 0x11, 0xf0, 0xee, 0x20, 0x80, 0xee, 0x11, 0xf2, 0x02, 0x0a, 0x90, 0xee,
    0x20, 0x92, 0x02, 0x03, 0x80, 0xff, 0x11, 0x80, 0xee, 0x11, 0x80, 0xff, 0x20, 0x82, 0x02, 0x08,
    0x80, 0xff, 0x11, 0x90, 0xee, 0x20, 0x80, 0xff, 0x20, 0x82, 0x02, 0x07, 0x80, 0xff, 0x11, 0x80,
    0xff, 0x20, 0xf0, 0xaf, 0x20, 0x65, 0x29, 0x00, 0x2d, 0x0a, 0x86, 0xd4, 0xff, 0x0c, 0x12, 0x46,
    0xd3, 0xff, 0xb6, 0x73, 0x3f, 0xe1, 0x31, 0x32, 0xd2, 0x02, 0x02, 0xf2, 0x02, 0x01, 0x80, 0xdd,
    0x11, 0xf0, 0xdd, 0x20, 0xe7, 0x9d, 0x2d, 0xa2, 0x02, 0x06, 0xb2, 0x02, 0x05, 0x80, 0xaa, 0x11,
    0xb0, 0xaa, 0x20, 0xb2, 0x02, 0x04, 0x80, 0xaa, 0x11, 0xb0, 0xaa, 0x20, 0xb2, 0x02, 0x03, 0x80,
    0xaa, 0x11, 0xb0, 0xaa, 0x20, 0x25, 0x3b, 0x00, 0x0c, 0x1b, 0xa0, 0xab, 0x93, 0x2d, 0x0a, 0x46,
    0xc3, 0xff, 0x00, 0x00, 0x00, 0x0c, 0x12, 0x46, 0xc1, 0xff, 0xd1, 0x32, 0x32, 0xc2, 0x02, 0x02,
    0xe2, 0x02, 0x01, 0x80, 0xcc, 0x11, 0xe0, 0xcc, 0x20, 0xd7, 0x9c, 0x0f, 0x65, 0x33, 0x00, 0x0c,
    0x1d, 0xa0, 0xad, 0x93, 0x2d, 0x0a, 0x86, 0xb9, 0xff, 0x00, 0x00, 0x00, 0x0c, 0x12, 0x86, 0xb7,
    0xff, 0x3b, 0xa2, 0xe5, 0x17, 0x00, 0x06, 0xb5, 0xff, 0xa2, 0x02, 0x02, 0xb2, 0x02, 0x01, 0x80,
    0xaa, 0x11, 0xb0, 0xaa, 0x20, 0x25, 0x10, 0x00, 0xc0, 0x20, 0x00, 0xa2, 0x64, 0x30, 0x06, 0xaf,
    0xff, 0xc2, 0xc3, 0xfd, 0x0c, 0x0d, 0x0c, 0x0e, 0xa2, 0x02, 0x02, 0xb2, 0x02, 0x01, 0x80, 0xaa,
    0x11, 0xb0, 0xaa, 0x20, 0x3b, 0xb2, 0x40, 0xaa, 0x11, 0x25, 0x1e, 0x00, 0x86, 0xa7, 0xff, 0x00,
    0x36, 0x61, 0x00, 0xbd, 0x03, 0xcd, 0x04, 0x7c, 0xfa, 0xcc, 0x32, 0x0c, 0x4d, 0x46, 0x03, 0x00,
    0xd2, 0xa0, 0x08, 0xc2, 0xc4, 0xfc, 0xb2, 0xc3, 0x04, 0xa2, 0x61, 0x00, 0x68, 0x03, 0x51, 0x2f,
    0x32, 0xa9, 0x01, 0xad, 0x05, 0x65, 0x70, 0x00, 0xad, 0x05, 0x25, 0x7a, 0x00, 0x0c, 0x03, 0x41,
    0x1d, 0x32, 0xc0, 0x20, 0x00, 0xc8, 0xd5, 0xb6, 0x3c, 0x02, 0x46, 0x21, 0x00, 0x56, 0x23, 0x08,
    0xd2, 0x24, 0xf3, 0x56, 0xcd, 0x07, 0xad, 0x05, 0x25, 0x84, 0x00, 0x16, 0x3a, 0xfe, 0x78, 0x05,
    0x8c, 0xd2, 0xad, 0x01, 0x50, 0xc7, 0xa0, 0x81, 0x33, 0x32, 0xb8, 0x5c, 0xc8, 0x9c, 0xe0, 0x08,
    0x00, 0xf6, 0x22, 0x56, 0xa1, 0x26, 0x32, 0x50, 0xd7, 0xa0, 0xb1, 0x27, 0x32, 0xc2, 0x2d, 0x05,
    0xd2, 0x2d, 0x09, 0x65, 0x9a, 0x00, 0xa0, 0x3a, 0x20, 0xac, 0xaa, 0x0c, 0x1b, 0xb9, 0xe5, 0xc0,
    0x20, 0x00, 0xf1, 0x05, 0x32, 0x92, 0x2f, 0xd8, 0x7c, 0x0a, 0xa0, 0x99, 0x10, 0xc0, 0x20, 0x00,
    0x92, 0x6f, 0xd8, 0xc0, 0x20, 0x00, 0xe2, 0x2f, 0xd8, 0x0c, 0x38, 0x80, 0xee, 0x20, 0xc0, 0x20,
    0x00, 0xe2, 0x6f, 0xd8, 0xc6, 0x04, 0x00, 0xc2, 0x24, 0xf3, 0x16, 0xdc, 0x00, 0xa2, 0xa0, 0x01,
    0x92, 0xa0, 0x01, 0x81, 0x04, 0x32, 0x99, 0xe5, 0xe0, 0x08, 0x00, 0xad, 0x05, 0x25, 0x82, 0x00,
    0x86, 0xdb, 0xff, 0xa8, 0x01, 0x8c, 0xb2, 0xa7, 0x16, 0x09, 0x81, 0x04, 0x32, 0x0c, 0x1a, 0xe0,
    0x08, 0x00, 0xa8, 0x01, 0x2d, 0x0a, 0x1d, 0xf0, 0x36, 0x41, 0x00, 0xbc, 0x02, 0x51, 0x34, 0x32,
    0x26, 0x12, 0x34, 0x26, 0x22, 0x36, 0x4c, 0xb3, 0x37, 0x12, 0x36, 0x42, 0xa1, 0x01, 0x47, 0x12,
    0x35, 0x82, 0xa1, 0x02, 0x87, 0x12, 0x34, 0x92, 0xa2, 0x01, 0x97, 0x12, 0x33, 0xa2, 0xa2, 0x02,
    0xa7, 0x12, 0x32, 0xb2, 0xa2, 0x03, 0xb7, 0x12, 0x31, 0xc2, 0xa2, 0x04, 0xc7, 0x12, 0x03, 0x0c,
    0x02, 0x1d, 0xf0, 0x22, 0x05, 0x0c, 0x1d, 0xf0, 0x22, 0x15, 0x00, 0x1d, 0xf0, 0x22, 0x05, 0x02,
    0x1d, 0xf0, 0x22, 0x15, 0x03, 0x1d, 0xf0, 0x22, 0x05, 0x03, 0x1d, 0xf0, 0x22, 0x05, 0x04, 0x1d,
    0xf0, 0x22, 0x05, 0x08, 0x1d, 0xf0, 0x22, 0x05, 0x09, 0x1d, 0xf0, 0x22, 0x15, 0x05, 0x1d, 0xf0,
    0x36, 0x41, 0x00, 0x0c, 0x17, 0x4c, 0xba, 0x81, 0x34, 0x32, 0xb2, 0xa1, 0x01, 0xd1, 0x35, 0x32,
    0xc2, 0xa2, 0x01, 0xe2, 0xa2, 0x02, 0xf2, 0xa2, 0x03, 0x0c, 0xb9, 0x52, 0x12, 0x00, 0x16, 0x45,
    0x07, 0x62, 0x12, 0x01, 0x4b, 0x22, 0x16, 0x15, 0xff, 0x26, 0x15, 0x55, 0x26, 0x25, 0x44, 0x97,
    0x15, 0x3b, 0xa7, 0x15, 0x2f, 0xb7, 0x15, 0x26, 0xc7, 0x15, 0x1d, 0xe7, 0x15, 0x14, 0xf7, 0x15,
    0x0b, 0x32, 0xa2, 0x04, 0x37, 0x95, 0x43, 0x62, 0x48, 0x0c, 0x46, 0xf3, 0xff, 0x62, 0x58, 0x05,
    0xc6, 0xf1, 0xff, 0x62, 0x48, 0x09, 0x46, 0xf0, 0xff, 0x62, 0x48, 0x08, 0xc6, 0xee, 0xff, 0x62,
    0x48, 0x03, 0x46, 0xed, 0xff, 0x60, 0x30, 0x64, 0x32, 0x58, 0x03, 0x06, 0xeb, 0xff, 0x62, 0x48,
    0x04, 0x86, 0xe9, 0xff, 0xf6, 0x46, 0x05, 0x62, 0x48, 0x02, 0x46, 0xe7, 0xff, 0x0c, 0x07, 0x06,
    0xe6, 0xff, 0x67, 0xbd, 0x05, 0x41, 0x36, 0x32, 0x67, 0xb4, 0x04, 0x0c, 0x07, 0x86, 0xe2, 0xff,
    0x62, 0x58, 0x00, 0x06, 0xe1, 0xff, 0x2d, 0x07, 0x1d, 0xf0, 0x00, 0x00, 0x36, 0x81, 0x00, 0x0c,
    0xda, 0x0c, 0x0b, 0x81, 0x03, 0x32, 0x29, 0x61, 0x69, 0x51, 0x2d, 0x03, 0x78, 0x61, 0x3d, 0x04,
    0x62, 0xc2, 0xf8, 0x4d, 0x05, 0x5d, 0x02, 0xe0, 0x08, 0x00, 0x49, 0x31, 0x69, 0x21, 0x29, 0x41,
    0xac, 0x14, 0xbd, 0x06, 0x69, 0x21, 0xad, 0x01, 0x8b, 0xc3, 0x7c, 0xf9, 0x81, 0x33, 0x32, 0x99,
    0x01, 0xe0, 0x08, 0x00, 0xa8, 0x31, 0x17, 0x6a, 0x0b, 0xc8, 0x51, 0xb8, 0x01, 0xc7, 0x1b, 0x04,
    0x0c, 0x02, 0x46, 0x2c, 0x00, 0x61, 0x37, 0x32, 0x16, 0x83, 0x06, 0x0c, 0x04, 0x82, 0xa0, 0xff,
    0x22, 0x05, 0x00, 0x52, 0xc5, 0x01, 0x87, 0x12, 0x50, 0xa2, 0xa0, 0x01, 0x65, 0x16, 0x00, 0xc1,
    0x34, 0x32, 0xc2, 0x0c, 0x08, 0xc0, 0x20, 0x00, 0x91, 0x2f, 0x32, 0xc2, 0x49, 0x58, 0x70, 0xb0,
    0xf5, 0xc0, 0x20, 0x00, 0xb2, 0x49, 0x59, 0x70, 0xa8, 0x41, 0xc0, 0x20, 0x00, 0xa2, 0x49, 0x5a,
    0xc0, 0x20, 0x00, 0x72, 0x49, 0x5b, 0xc0, 0x20, 0x00, 0x22, 0x49, 0x5c, 0xa2, 0xa0, 0x05, 0xe5,
    0x44, 0x00, 0xc0, 0x20, 0x00, 0xd2, 0x26, 0xcc, 0x07, 0x6d, 0x08, 0xc0, 0x20, 0x00, 0xe2, 0x26,
    0xcc, 0x07, 0xee, 0xf6, 0xe5, 0x14, 0x00, 0x07, 0xea, 0xf9, 0x1b, 0x77, 0x82, 0xa0, 0xff, 0x1b,
    0x44, 0x47, 0x93, 0x9b, 0x88, 0x31, 0x07, 0x68, 0x3b, 0xa8, 0x61, 0xbd, 0x03, 0xc8, 0x41, 0xe5,
    0x1b, 0x00, 0xc0, 0x20, 0x00, 0x92, 0x26, 0xcc, 0x07, 0x69, 0x08, 0xc0, 0x20, 0x00, 0xa2, 0x26,
    0xcc, 0x07, 0xea, 0xf6, 0xb8, 0x21, 0x8b, 0xc3, 0x4b, 0xa1, 0x7c, 0xf9, 0x81, 0x33, 0x32, 0x99,
    0x11, 0xe0, 0x08, 0x00, 0x0c, 0x1a, 0xc8, 0x11, 0xb8, 0x01, 0x0c, 0x02, 0xc0, 0xbb, 0xc0, 0xb0,
    0x2a, 0x83, 0x46, 0x00, 0x00, 0x0c, 0x12, 0x0c, 0xda, 0x81, 0x03, 0x32, 0x0c, 0x1b, 0xe0, 0x08,
    0x00, 0x1d, 0xf0, 0x00, 0x36, 0x41, 0x00, 0xe5, 0x0e, 0x00, 0x0c, 0x1a, 0x65, 0x0b, 0x00, 0x0c,
    0x2a, 0x25, 0x13, 0x00, 0xe5, 0x0d, 0x00, 0xa0, 0x80, 0x74, 0x8c, 0x28, 0x0c, 0x02, 0x1d, 0xf0,
    0x0c, 0x1a, 0x25, 0x0a, 0x00, 0x91, 0x34, 0x32, 0xa1, 0x2f, 0x32, 0x92, 0x09, 0x0c, 0xc0, 0x20,
    0x00, 0x92, 0x4a, 0x58, 0x0c, 0x1a, 0x65, 0x3a, 0x00, 0x91, 0x37, 0x32, 0xc0, 0x20, 0x00, 0xb2,
    0x29, 0xcc, 0x07, 0x6b, 0x08, 0xc0, 0x20, 0x00, 0xc2, 0x29, 0xcc, 0x07, 0xec, 0xf6, 0x65, 0x0a,
    0x00, 0x07, 0xea, 0xf9, 0x0c, 0x12, 0x1d, 0xf0, 0x36, 0x41, 0x00, 0xa5, 0x09, 0x00, 0x0c, 0x1a,
    0x25, 0x06, 0x00, 0x0c, 0x2a, 0xe5, 0x0d, 0x00, 0xa5, 0x08, 0x00, 0xa0, 0x80, 0x74, 0x8c, 0x28,
    0x0c, 0x02, 0x1d, 0xf0, 0x0c, 0x1a, 0xe5, 0x04, 0x00, 0xc1, 0x34, 0x32, 0x91, 0x2f, 0x32, 0xc2,
    0x0c, 0x09, 0xc0, 0x20, 0x00, 0xc2, 0x49, 0x58, 0x20, 0xb0, 0xf5, 0xc0, 0x20, 0x00, 0xb2, 0x49,
    0x59, 0x20, 0xa8, 0x41, 0xc0, 0x20, 0x00, 0xa2, 0x49, 0x5a, 0xc0, 0x20, 0x00, 0x22, 0x49, 0x5b,
    0x0c, 0x4a, 0xa5, 0x33, 0x00, 0x91, 0x37, 0x32, 0xc0, 0x20, 0x00, 0xd2, 0x29, 0xcc, 0x07, 0x6d,
    0x08, 0xc0, 0x20, 0x00, 0xe2, 0x29, 0xcc, 0x07, 0xee, 0xf6, 0xa5, 0x03, 0x00, 0x07, 0xea, 0xf9,
    0x0c, 0x12, 0x1d, 0xf0, 0x36, 0x41, 0x00, 0x0c, 0x6a, 0x0c, 0x48, 0x91, 0x2f, 0x32, 0x20, 0x8a,
    0x93, 0xc0, 0x20, 0x00, 0x0c, 0x1a, 0x82, 0x49, 0x58, 0x25, 0x30, 0x00, 0x91, 0x37, 0x32, 0xc0,
    0x20, 0x00, 0xb2, 0x29, 0xcc, 0x07, 0x6b, 0x08, 0xc0, 0x20, 0x00, 0xc2, 0x29, 0xcc, 0x07, 0xec,
    0xf6, 0x1d, 0xf0, 0x00, 0x36, 0x41, 0x00, 0x21, 0x37, 0x32, 0xb1, 0x2c, 0x32, 0x31, 0x38, 0x32,
    0xc1, 0x2d, 0x32, 0xb0, 0xb3, 0x10, 0xc0, 0x20, 0x00, 0xa2, 0x22, 0x80, 0xc0, 0xaa, 0x10, 0xb0,
    0xaa, 0x20, 0xc0, 0x20, 0x00, 0xa2, 0x62, 0x80, 0x92, 0xc3, 0xa0, 0x0c, 0x58, 0xc0, 0x20, 0x00,
    0x0c, 0x1a, 0x0c, 0x1b, 0x82, 0x49, 0x58, 0x65, 0x2e, 0x00, 0xc0, 0x20, 0x00, 0xc2, 0x22, 0xcc,
    0x07, 0x6c, 0x08, 0xc0, 0x20, 0x00, 0xd2, 0x22, 0xcc, 0x07, 0xed, 0xf6, 0xc0, 0x20, 0x00, 0x22,
    0x03, 0x00, 0x1d, 0xf0, 0x36, 0x41, 0x00, 0x0c, 0x19, 0x81, 0x2f, 0x32, 0xc0, 0x20, 0x00, 0x92,
    0x48, 0x58, 0xc0, 0x20, 0x00, 0x0c, 0x2a, 0x22, 0x48, 0x59, 0x25, 0x28, 0x00, 0x91, 0x37, 0x32,
    0xc0, 0x20, 0x00, 0xb2, 0x29, 0xcc, 0x07, 0x6b, 0x08, 0xc0, 0x20, 0x00, 0xc2, 0x29, 0xcc, 0x07,
    0xec, 0xf6, 0x25, 0xf8, 0xff, 0x07, 0xea, 0xf9, 0x1d, 0xf0, 0x00, 0x00, 0x36, 0x41, 0x00, 0xa1,
    0x34, 0x32, 0xbd, 0x03, 0x92, 0x0a, 0x04, 0xc1, 0x2f, 0x32, 0xcc, 0xc9, 0x82, 0x0a, 0x03, 0xc0,
    0x20, 0x00, 0x82, 0x4c, 0x58, 0x0c, 0x4a, 0xc6, 0x03, 0x00, 0xc0, 0x20, 0x00, 0x92, 0x4c, 0x58,
    0x0c, 0x0a, 0xc0, 0x20, 0x00, 0xa2, 0x4c, 0x5c, 0x0c, 0x5a, 0x20, 0x80, 0xf5, 0xd1, 0x37, 0x32,
    0xc0, 0x20, 0x00, 0x82, 0x4c, 0x59, 0x20, 0xf8, 0x41, 0xc0, 0x20, 0x00, 0xf2, 0x4c, 0x5a, 0xc0,
    0x20, 0x00, 0x22, 0x4c, 0x5b, 0xe1, 0x2c, 0x32, 0xf1, 0x2d, 0x32, 0xe0, 0xe4, 0x10, 0xc0, 0x20,
    0x00, 0xc2, 0x2d, 0x80, 0xf0, 0xcc, 0x10, 0xe0, 0xcc, 0x20, 0xc0, 0x20, 0x00, 0xc2, 0x6d, 0x80,
    0xa5, 0x22, 0x00, 0x1d, 0xf0, 0x00, 0x00, 0x00, 0x36, 0x41, 0x00, 0x0c, 0x0b, 0x5c, 0x8c, 0x31,
    0x2f, 0x32, 0x81, 0x39, 0x32, 0xad, 0x03, 0xe0, 0x08, 0x00, 0xb1, 0x3a, 0x32, 0xc1, 0x3b, 0x32,
    0xc0, 0x20, 0x00, 0x91, 0x3c, 0x32, 0xb2, 0x6c, 0xa2, 0x0c, 0x3a, 0xb1, 0x3e, 0x32, 0xc2, 0xa0,
    0xf2, 0xa9, 0x32, 0x99, 0x42, 0xa1, 0x3d, 0x32, 0x25, 0x4f, 0x00, 0xa1, 0x3f, 0x32, 0xb1, 0x3e,
    0x32, 0xc2, 0xa0, 0xf2, 0x65, 0x4e, 0x00, 0xa1, 0x40, 0x32, 0xb1, 0x3e, 0x32, 0xc2, 0xa0, 0xf2,
    0xa5, 0x4d, 0x00, 0xa1, 0x41, 0x32, 0xb1, 0x3e, 0x32, 0xc2, 0xa0, 0xf1, 0xe5, 0x4c, 0x00, 0xa5,
    0x06, 0x00, 0xa1, 0x42, 0x32, 0xb1, 0x43, 0x32, 0x25, 0x4e, 0x00, 0xa1, 0x44, 0x32, 0xb1, 0x2c,
    0x32, 0xc1, 0x45, 0x32, 0x65, 0x4b, 0x00, 0xa1, 0x46, 0x32, 0xb1, 0x47, 0x32, 0x0c, 0x7c, 0xe5,
    0x4a, 0x00, 0xa1, 0x48, 0x32, 0x0c, 0x3b, 0x0c, 0x1c, 0x25, 0x4a, 0x00, 0xa1, 0x48, 0x32, 0xb2,
    0xa0, 0x70, 0x0c, 0x0c, 0x65, 0x49, 0x00, 0xa1, 0x49, 0x32, 0xc8, 0x42, 0xb1, 0x47, 0x32, 0x0b,
    0xcc, 0xa5, 0x48, 0x00, 0xa1, 0x4a, 0x32, 0xb2, 0xa0, 0x73, 0x0c, 0x1c, 0xe5, 0x47, 0x00, 0xcd,
    0x03, 0x0c, 0xda, 0x81, 0x1b, 0x32, 0xb1, 0x4b, 0x32, 0xe0, 0x08, 0x00, 0xa1, 0x4c, 0x32, 0x1c,
    0xcb, 0x0c, 0x0c, 0xa5, 0x46, 0x00, 0x1d, 0xf0, 0x36, 0x41, 0x00, 0xa1, 0x4d, 0x32, 0xb1, 0x10,
    0x32, 0x0c, 0x0c, 0xa5, 0x45, 0x00, 0xa1, 0x4e, 0x32, 0xb1, 0x43, 0x32, 0xe5, 0x46, 0x00, 0x31,
    0x23, 0x32, 0x82, 0x13, 0x20, 0x21, 0x34, 0x32, 0x87, 0x68, 0x37, 0xa1, 0x4f, 0x32, 0xb2, 0xa4,
    0x00, 0xc2, 0xa4, 0x00, 0x65, 0x43, 0x00, 0x81, 0x07, 0x32, 0xa2, 0xa3, 0xe8, 0xe0, 0x08, 0x00,
    0xa1, 0x50, 0x32, 0xb1, 0x43, 0x32, 0xc1, 0x43, 0x32, 0x25, 0x42, 0x00, 0xa1, 0x4f, 0x32, 0x3c,
    0x0b, 0x1c, 0x0c, 0xa5, 0x41, 0x00, 0xa1, 0x51, 0x32, 0x0c, 0xcb, 0x0c, 0x0c, 0xe5, 0x40, 0x00,
    0x86, 0x15, 0x00, 0xa1, 0x52, 0x32, 0xb1, 0x53, 0x32, 0xc1, 0x54, 0x32, 0xe5, 0x3f, 0x00, 0xb2,
    0x12, 0x00, 0xc1, 0x55, 0x32, 0x0c, 0x1a, 0xb7, 0x3c, 0x0b, 0xf0, 0xaa, 0x11, 0xf0, 0xbb, 0x11,
    0xb7, 0xbc, 0xf6, 0x46, 0x00, 0x00, 0x0c, 0x1a, 0x81, 0x56, 0x32, 0x0b, 0x9a, 0x92, 0x42, 0x0e,
    0xa1, 0x57, 0x32, 0xe0, 0x08, 0x00, 0xb2, 0xda, 0x08, 0xb0, 0xbc, 0x41, 0xf0, 0xbb, 0x11, 0xb2,
    0x42, 0x0d, 0xc2, 0xa2, 0x00, 0xb0, 0xb0, 0x74, 0xc0, 0xbb, 0x20, 0xc0, 0x20, 0x00, 0xb2, 0x53,
    0x90, 0xa1, 0x58, 0x32, 0xc0, 0x20, 0x00, 0xa2, 0x53, 0x80, 0xa1, 0x4c, 0x32, 0xb1, 0x59, 0x32,
    0xc2, 0x02, 0x02, 0xd2, 0x02, 0x0e, 0xc0, 0xe1, 0x04, 0x20, 0xdd, 0x11, 0xc0, 0xc0, 0x04, 0xf0,
    0xee, 0x11, 0xe0, 0xdd, 0x20, 0xd0, 0xcc, 0x20, 0x25, 0x39, 0x00, 0x1d, 0xf0, 0x00, 0x00, 0x00,
    0x36, 0x41, 0x00, 0xa1, 0x3d, 0x32, 0xb1, 0x3e, 0x32, 0x0c, 0x8c, 0x25, 0x38, 0x00, 0xa1, 0x40,
    0x32, 0xb1, 0x3e, 0x32, 0x0c, 0x8c, 0x65, 0x37, 0x00, 0xa1, 0x41, 0x32, 0xb1, 0x3e, 0x32, 0x0c,
    0x8c, 0xa5, 0x36, 0x00, 0xa1, 0x3f, 0x32, 0xb1, 0x3e, 0x32, 0x0c, 0x8c, 0xe5, 0x35, 0x00, 0xa1,
    0x5a, 0x32, 0xb1, 0x43, 0x32, 0x65, 0x37, 0x00, 0x0c, 0xda, 0x81, 0x03, 0x32, 0x0c, 0x0b, 0xe0,
    0x08, 0x00, 0xb1, 0x5b, 0x32, 0xa1, 0x20, 0x32, 0xc0, 0x20, 0x00, 0xb2, 0x6a, 0x88, 0x91, 0x5c,
    0x32, 0xc0, 0x20, 0x00, 0x92, 0x6a, 0x88, 0x1d, 0xf0, 0x00, 0x00, 0x00, 0x36, 0x41, 0x00, 0xa1,
    0x5d, 0x32, 0xb1, 0x47, 0x32, 0x0c, 0x0c, 0x65, 0x32, 0x00, 0xa1, 0x4c, 0x32, 0xb1, 0x5e, 0x32,
    0xc1, 0x5f, 0x32, 0xa5, 0x31, 0x00, 0xcd, 0x02, 0xa1, 0x60, 0x32, 0x7c, 0xfb, 0xe5, 0x30, 0x00,
    0xa1, 0x61, 0x32, 0x0c, 0x1b, 0x0c, 0x1c, 0x65, 0x30, 0x00, 0x1d, 0xf0, 0x36, 0x41, 0x00, 0xa1,
    0x5d, 0x32, 0xb1, 0x47, 0x32, 0x0c, 0x0c, 0x65, 0x2f, 0x00, 0xa1, 0x62, 0x32, 0xb1, 0x47, 0x32,
    0x0c, 0x0c, 0xa5, 0x2e, 0x00, 0xa1, 0x4c, 0x32, 0xb1, 0x5e, 0x32, 0xc1, 0x63, 0x32, 0xe5, 0x2d,
    0x00, 0xa1, 0x60, 0x32, 0x7c, 0xfb, 0x80, 0xc2, 0x01, 0xc0, 0xc3, 0x20, 0xe5, 0x2c, 0x00, 0xa1,
    0x61, 0x32, 0x0c, 0x1b, 0x0c, 0x1c, 0x65, 0x2c, 0x00, 0x1d, 0xf0, 0x00, 0x36, 0x41, 0x00, 0x61,
    0x38, 0x32, 0x82, 0xa0, 0x80, 0x47, 0x38, 0x0d, 0xbd, 0x03, 0xad, 0x06, 0x81, 0x64, 0x32, 0xcd,
    0x04, 0xe0, 0x08, 0x00, 0x3d, 0x06, 0x0c, 0x0e, 0xdd, 0x02, 0xcd, 0x0e, 0xc0, 0x20, 0x00, 0x39,
    0xf2, 0xe9, 0xe2, 0xe9, 0xd2, 0xc0, 0x20, 0x00, 0x42, 0x62, 0x10, 0xc0, 0x20, 0x00, 0xe2, 0x62,
    0x12, 0xc0, 0x20, 0x00, 0xe2, 0x62, 0x13, 0xc0, 0x20, 0x00, 0xe2, 0x62, 0x14, 0xe2, 0x62, 0x15,
    0xa1, 0x02, 0x32, 0x0c, 0x49, 0x76, 0xa9, 0x1a, 0xc0, 0x20, 0x00, 0xb2, 0x2a, 0x1a, 0x4b, 0xaa,
    0x67, 0x13, 0x07, 0xf8, 0xf2, 0x50, 0xff, 0xc0, 0xf7, 0x1b, 0x05, 0x1b, 0xcc, 0xb9, 0x5d, 0x4b,
    0xdd, 0x3d, 0xf0, 0xc9, 0x32, 0xe9, 0x02, 0xc1, 0x3c, 0x32, 0xc9, 0x42, 0xa1, 0x37, 0x32, 0xc0,
    0x20, 0x00, 0xb8, 0x42, 0xe9, 0x12, 0x0b, 0xbb, 0xc1, 0x10, 0x32, 0xb0, 0xb0, 0xf4, 0xc0, 0x20,
    0x00, 0x92, 0x2a, 0x84, 0xc0, 0x99, 0x10, 0xb0, 0x99, 0x20, 0xc0, 0x20, 0x00, 0x0c, 0x1b, 0x92,
    0x6a, 0x84, 0x81, 0x03, 0x32, 0x0c, 0xda, 0xe0, 0x08, 0x00, 0x1d, 0xf0, 0x36, 0x41, 0x00, 0xc0,
    0x20, 0x00, 0x88, 0xd2, 0x98, 0xe2, 0x56, 0x68, 0x0a, 0x56, 0x39, 0x0a, 0xc0, 0x20, 0x00, 0xa2,
    0x22, 0x12, 0x56, 0x2a, 0x04, 0xc0, 0x20, 0x00, 0xb2, 0x22, 0x10, 0x88, 0xf2, 0xb6, 0x8b, 0x37,
    0x88, 0x08, 0xc0, 0x20, 0x00, 0x82, 0x62, 0x11, 0xf8, 0xf2, 0xf8, 0x1f, 0xc0, 0x20, 0x00, 0xe8,
    0xf2, 0xf2, 0x62, 0x12, 0x8b, 0xee, 0xe9, 0xf2, 0xc0, 0x20, 0x00, 0xd2, 0x22, 0x10, 0xd2, 0xcd,
    0xf8, 0xc0, 0x20, 0x00, 0xd2, 0x62, 0x10, 0xc0, 0x20, 0x00, 0xc2, 0x22, 0x12, 0xcc, 0x7c, 0x91,
    0x65, 0x32, 0xc0, 0x20, 0x00, 0x92, 0x62, 0x12, 0xc0, 0x20, 0x00, 0xa2, 0x22, 0x12, 0x0c, 0x1c,
    0x16, 0xea, 0x04, 0xc0, 0x20, 0x00, 0x82, 0x22, 0x12, 0xc0, 0x20, 0x00, 0x38, 0x42, 0xc8, 0x12,
    0x80, 0x33, 0x63, 0x20, 0xcc, 0xa0, 0xc8, 0x5c, 0xc0, 0x20, 0x00, 0xa2, 0x22, 0x11, 0xbd, 0x03,
    0xa5, 0xc0, 0xff, 0xc0, 0x20, 0x00, 0xb2, 0x22, 0x11, 0x3a, 0xbb, 0xc0, 0x20, 0x00, 0xb2, 0x62,
    0x11, 0xc0, 0x20, 0x00, 0xa2, 0x22, 0x12, 0x30, 0xaa, 0xc0, 0xc0, 0x20, 0x00, 0xa2, 0x62, 0x12,
    0xc0, 0x20, 0x00, 0x92, 0x22, 0x13, 0x1b, 0x99, 0xc0, 0x20, 0x00, 0x92, 0x62, 0x13, 0x1d, 0xf0,
    0x1d, 0xf0, 0xc0, 0x20, 0x00, 0xc9, 0xd2, 0x1d, 0xf0, 0x00, 0x00, 0x00, 0x36, 0x41, 0x00, 0xc0,
    0x20, 0x00, 0x88, 0xd2, 0xb6, 0x38, 0x03, 0x0c, 0x02, 0x1d, 0xf0, 0x0c, 0xda, 0x81, 0x03, 0x32,
    0x0c, 0x0b, 0xe0, 0x08, 0x00, 0x0c, 0x13, 0xc0, 0x20, 0x00, 0xa8, 0x12, 0x98, 0x02, 0xa7, 0x99,
    0x09, 0xc0, 0x20, 0x00, 0xc8, 0x22, 0x0c, 0x0b, 0xc0, 0x3b, 0x83, 0x0c, 0xda, 0x81, 0x03, 0x32,
    0x0c, 0x1b, 0xe0, 0x08, 0x00, 0xcc, 0x63, 0xc0, 0x20, 0x00, 0x98, 0xd2, 0xb6, 0x29, 0xcb, 0xc0,
    0x20, 0x00, 0xa8, 0xd2, 0x0c, 0x12, 0xb6, 0x3a, 0x03, 0x0c, 0x02, 0x1d, 0xf0, 0x1d, 0xf0, 0x00,
    0x36, 0x41, 0x00, 0x0c, 0xda, 0x0c, 0x0b, 0x92, 0x22, 0x15, 0x81, 0x03, 0x32, 0x1b, 0x99, 0x92,
    0x62, 0x15, 0xe0, 0x08, 0x00, 0x0c, 0x03, 0xa8, 0x02, 0xb8, 0x32, 0x1b, 0xaa, 0xa9, 0x02, 0xb7,
    0x3a, 0x01, 0x39, 0x02, 0xc0, 0x20, 0x00, 0xb8, 0x22, 0x8c, 0x9b, 0xa1, 0x2f, 0x32, 0xe5, 0xeb,
    0xff, 0xc0, 0x20, 0x00, 0x39, 0x22, 0x0c, 0xda, 0x81, 0x03, 0x32, 0x0c, 0x1b, 0xe0, 0x08, 0x00,
    0x0c, 0x3a, 0xc0, 0x20, 0x00, 0x98, 0xd2, 0xb8, 0xe2, 0xf6, 0x29, 0x24, 0xac, 0x1b, 0xc0, 0x20,
    0x00, 0xd2, 0x22, 0x13, 0xc0, 0x20, 0x00, 0xc2, 0x22, 0x14, 0xd7, 0xbc, 0x0e, 0xc0, 0x20, 0x00,
    0xf2, 0x22, 0x13, 0xc0, 0x20, 0x00, 0xe2, 0x22, 0x14, 0xf7, 0x3e, 0xf0, 0xc0, 0x20, 0x00, 0xa9,
    0xd2, 0xc0, 0x20, 0x00, 0x88, 0xd2, 0x66, 0x18, 0x15, 0xc0, 0x20, 0x00, 0xb2, 0x22, 0x13, 0xc0,
    0x20, 0x00, 0x92, 0x22, 0x14, 0x0c, 0x2c, 0xb7, 0x39, 0x04, 0xc0, 0x20, 0x00, 0xc9, 0xd2, 0xc0,
    0x20, 0x00, 0xd8, 0xd2, 0x66, 0x2d, 0x10, 0xc0, 0x20, 0x00, 0xf2, 0x22, 0x14, 0xe2, 0x22, 0x15,
    0xf7, 0x3e, 0x04, 0xc0, 0x20, 0x00, 0xa9, 0xd2, 0x1d, 0xf0, 0x00, 0x00, 0x36, 0x41, 0x00, 0xd1,
    0x3a, 0x32, 0xe1, 0x3b, 0x32, 0xc0, 0x20, 0x00, 0xd2, 0x6e, 0xa2, 0xc0, 0x20, 0x00, 0xb8, 0x12,
    0xc1, 0x37, 0x32, 0x20, 0xdb, 0xa0, 0xc0, 0x20, 0x00, 0xc2, 0x2c, 0x98, 0x0c, 0x0a, 0xc0, 0xc0,
    0xf4, 0xc9, 0x9d, 0x88, 0x32, 0x1b, 0xbb, 0x87, 0xbb, 0x01, 0xad, 0x0b, 0xc0, 0x20, 0x00, 0xa9,
    0x12, 0xc0, 0x20, 0x00, 0x88, 0x12, 0xf8, 0x02, 0x0c, 0x19, 0x87, 0x9f, 0x07, 0xc0, 0x20, 0x00,
    0x99, 0x22, 0x46, 0x01, 0x00, 0xa1, 0x2f, 0x32, 0x25, 0xdf, 0xff, 0xc0, 0x20, 0x00, 0xa2, 0x22,
    0x14, 0x1b, 0xaa, 0xc0, 0x20, 0x00, 0xa2, 0x62, 0x14, 0x1d, 0xf0, 0x00, 0x36, 0x41, 0x00, 0x40,
    0x63, 0x10, 0x7c, 0xf7, 0x70, 0x73, 0x30, 0xc0, 0x20, 0x00, 0x58, 0x02, 0x70, 0x55, 0x10, 0x60,
    0x55, 0x20, 0xc0, 0x20, 0x00, 0x59, 0x02, 0x1d, 0xf0, 0x00, 0x00, 0x00, 0x36, 0x41, 0x00, 0xc0,
    0x20, 0x00, 0x39, 0x02, 0x1d, 0xf0, 0x00, 0x00, 0x36, 0x61, 0x00, 0x29, 0x11, 0x39, 0x01, 0xac,
    0xf5, 0x31, 0x66, 0x32, 0x71, 0x29, 0x32, 0xe2, 0xc3, 0x10, 0xc2, 0xc7, 0x10, 0x98, 0x07, 0x0c,
    0x06, 0xac, 0xe9, 0x26, 0x19, 0x7f, 0x66, 0x29, 0x15, 0xdd, 0x05, 0xa8, 0x11, 0xb8, 0x01, 0x81,
    0x67, 0x32, 0xcd, 0x04, 0xe0, 0x08, 0x00, 0xe1, 0x68, 0x32, 0xc1, 0x69, 0x32, 0x0c, 0x05, 0x56,
    0xa5, 0xfd, 0xa8, 0x11, 0x0c, 0x19, 0xa2, 0x2a, 0x27, 0x0c, 0x02, 0xa2, 0xca, 0xf8, 0xa0, 0x29,
    0x83, 0x1d, 0xf0, 0xd8, 0x17, 0x0c, 0x0f, 0x3a, 0x2d, 0x57, 0xb6, 0xe2, 0x56, 0xff, 0xfd, 0x0b,
    0x55, 0xca, 0x9d, 0xb2, 0x04, 0x00, 0x82, 0x02, 0x00, 0x1b, 0x44, 0x1b, 0x22, 0x1b, 0xdd, 0xb2,
    0x49, 0x00, 0xd9, 0x17, 0x87, 0x1b, 0x1f, 0xa8, 0x11, 0xb8, 0x01, 0x81, 0x67, 0x32, 0xc1, 0x69,
    0x32, 0xe0, 0x08, 0x00, 0xe1, 0x68, 0x32, 0xc1, 0x69, 0x32, 0x0c, 0x29, 0x99, 0x07, 0x0c, 0x1f,
    0x0c, 0x0d, 0xd9, 0x17, 0x86, 0x00, 0x00, 0x26, 0xbd, 0x04, 0x1b, 0x66, 0x46, 0xee, 0xff, 0x0c,
    0x1a, 0xa9, 0x07, 0xc6, 0xf9, 0xff, 0x0c, 0x0f, 0xd8, 0x17, 0x0c, 0x06, 0xea, 0x2d, 0x57, 0xb6,
    0x8d, 0x56, 0xaf, 0xf8, 0x0b, 0x55, 0x1b, 0x66, 0xb2, 0x02, 0x00, 0x82, 0x04, 0x00, 0x1b, 0x44,
    0x87, 0x1b, 0x08, 0x2d, 0x0e, 0x0c, 0x0d, 0xd9, 0x17, 0x06, 0x04, 0x00, 0x1b, 0x22, 0x1c, 0x19,
    0x1b, 0xdd, 0xd9, 0x17, 0x97, 0x9d, 0x05, 0x0c, 0x1f, 0x0c, 0x2a, 0xa9, 0x07, 0x46, 0xf3, 0xff,
    0x36, 0x41, 0x00, 0x41, 0x0a, 0x32, 0x82, 0x04, 0x89, 0x80, 0x84, 0x04, 0x16, 0xd8, 0x16, 0xc2,
    0xae, 0x0f, 0x2c, 0x05, 0x3c, 0x02, 0x31, 0x6a, 0x32, 0xa1, 0x05, 0x32, 0xc0, 0x20, 0x00, 0xb2,
    0x2a, 0xd8, 0xc0, 0xbb, 0x10, 0xc0, 0x20, 0x00, 0xb2, 0x6a, 0xd8, 0xc0, 0x20, 0x00, 0x92, 0x2a,
    0xd8, 0x20, 0x99, 0x20, 0xc0, 0x20, 0x00, 0x92, 0x6a, 0xd8, 0xc0, 0x20, 0x00, 0x52, 0x63, 0x88,
    0x81, 0x07, 0x32, 0x1c, 0xea, 0xe0, 0x08, 0x00, 0xc0, 0x20, 0x00, 0x22, 0x63, 0x88, 0x81, 0x07,
    0x32, 0x1c, 0xea, 0xe0, 0x08, 0x00, 0x92, 0xa2, 0x30, 0xc0, 0x20, 0x00, 0x92, 0x63, 0x88, 0x81,
    0x07, 0x32, 0x1c, 0xea, 0xe0, 0x08, 0x00, 0x92, 0xa3, 0x30, 0xc0, 0x20, 0x00, 0x92, 0x63, 0x88,
    0x81, 0x07, 0x32, 0x1c, 0xea, 0xe0, 0x08, 0x00, 0x91, 0x6b, 0x32, 0xc0, 0x20, 0x00, 0x92, 0x63,
    0x84, 0x81, 0x07, 0x32, 0x1c, 0xea, 0xe0, 0x08, 0x00, 0x91, 0x6c, 0x32, 0xc0, 0x20, 0x00, 0x92,
    0x63, 0x84, 0x81, 0x07, 0x32, 0x1c, 0xea, 0xe0, 0x08, 0x00, 0x92, 0xa1, 0x30, 0xc0, 0x20, 0x00,
    0x92, 0x63, 0x88, 0x81, 0x07, 0x32, 0x1c, 0xea, 0xe0, 0x08, 0x00, 0x91, 0x6d, 0x32, 0x21, 0x23,
    0x32, 0xc0, 0x20, 0x00, 0x92, 0x52, 0x38, 0x81, 0x07, 0x32, 0x1c, 0xea, 0xe0, 0x08, 0x00, 0x91,
    0x6e, 0x32, 0xc0, 0x20, 0x00, 0x92, 0x52, 0x38, 0x81, 0x07, 0x32, 0x1c, 0xea, 0xe0, 0x08, 0x00,
    0x92, 0xa3, 0x3f, 0xc0, 0x20, 0x00, 0x92, 0x52, 0x30, 0x81, 0x07, 0x32, 0x1c, 0xea, 0xe0, 0x08,
    0x00, 0x92, 0xa1, 0x1c, 0xc0, 0x20, 0x00, 0x92, 0x52, 0x20, 0x81, 0x07, 0x32, 0x1c, 0xea, 0xe0,
    0x08, 0x00, 0x92, 0xa1, 0x10, 0xc0, 0x20, 0x00, 0x92, 0x63, 0x88, 0x81, 0x07, 0x32, 0x1c, 0xea,
    0xe0, 0x08, 0x00, 0xc0, 0x20, 0x00, 0x52, 0x52, 0x20, 0x81, 0x07, 0x32, 0x1c, 0xea, 0xe0, 0x08,
    0x00, 0x92, 0xa1, 0x08, 0xc0, 0x20, 0x00, 0x92, 0x52, 0x68, 0x81, 0x07, 0x32, 0x1c, 0xea, 0xe0,
    0x08, 0x00, 0x1c, 0x99, 0xc0, 0x20, 0x00, 0x92, 0x52, 0x58, 0x81, 0x07, 0x32, 0xa2, 0xa1, 0x2c,
    0xe0, 0x08, 0x00, 0x92, 0x04, 0x8a, 0xb2, 0xa1, 0x00, 0xcc, 0xa9, 0xa2, 0xa1, 0x1b, 0xc0, 0x20,
    0x00, 0xa2, 0x52, 0x70, 0x06, 0x02, 0x00, 0xb0, 0xb9, 0x20, 0xc0, 0x20, 0x00, 0xb2, 0x52, 0x70,
    0x81, 0x07, 0x32, 0x1c, 0xea, 0xe0, 0x08, 0x00, 0x7c, 0xdd, 0xa1, 0x20, 0x32, 0xc0, 0x20, 0x00,
    0xc2, 0x2a, 0x98, 0xd0, 0xcc, 0x10, 0xc0, 0x20, 0x00, 0xc2, 0x6a, 0x98, 0x7c, 0xeb, 0xc0, 0x20,
    0x00, 0x92, 0x2a, 0x98, 0xb0, 0x99, 0x10, 0xc0, 0x20, 0x00, 0x92, 0x6a, 0x98, 0x1d, 0xf0, 0x00,
    0x00, 0x00, 0x00, 0x00
]

si_rom_patch = (b''.join((struct.pack('<B',x) for x in si_rom_patch)))

def cmd_write_flash(args):
    d = args.device

    d.run_simple_command('si_reset')
    d.run_simple_command('status')
    d.do_si_load_init()

    for x in range(0,len(si_rom_patch), 512):
        blob = si_rom_patch[x:x+512]
        d.do_si_command(struct.pack('<BBBB', 0x04, 0x0, 0x0, 0x0) + blob)
        d.read_si_reply()

    d.run_simple_command('status')

    data = args.flash_file.read()
    for x in range(0,len(data), 512):
        blob = data[x:x+512]
        d.do_si_write_flash(x + args.offset, blob)

    #d.do_si_load_init()

    #firmware = args.f.read()
    #for x in range(0,len(firmware), 512):
    #blob = firmware[x:x+512]
    #    d.do_si_command(struct.pack('<BBBB', 0x04, 0x0, 0x0, 0x0) + blob)
    #    d.read_si_reply()

    #d.do_si_command(struct.pack('<BB', 0x07, 0x0))
    #d.read_si_reply()

    #d.run_simple_command('status')

def int_argument(string):
    return int(string,0)


def main():
    parser = argparse.ArgumentParser(u'Radio Shield console control utility')

    parser.add_argument('device', type=ConsoleHandler.argument,
                        help = u'serial device to open')

    subparsers = parser.add_subparsers(help=u'sub-command help')

    s = subparsers.add_parser('write_flash', help=u'Writeto SI4688 attached flash memory')
    s.add_argument('offset',     type=int_argument, help='start offset to read from flash')
    s.add_argument('flash_file', type=argparse.FileType('rb'), help='file containing data to flash')
    s.set_defaults(func=cmd_write_flash)

    args = parser.parse_args()

    args.device.prepare()

    args.func(args)

    args.device.close()

if __name__ == '__main__':
    main()
